//
//  NEXVector3D.h
//  NumberEightCompiled
//
//  Created by Matthew Paletta on 2021-05-20.
//  Copyright © 2021 NumberEight Technologies Ltd. All rights reserved.
//
#pragma once

#import "NEVector3D.h"
#import "NEXSensorItem.h"

NS_ASSUME_NONNULL_BEGIN

/**
 * Encapsulates a 3-dimensional vector of double-precision floating point numbers.
 */
@interface NEXVector3D : NEXSensorItem

/**
 * Default constructor.
 */
- (instancetype)init;

/**
 * Default constructor.
 */
+ (instancetype)new;

/**
 * Conversion copy constructor.
 * @param vector3d NEVector3D to copy from.
 */
- (instancetype)initWithVector3D:(NEVector3D)vector3d;

/**
 * Conversion copy constructor.
 * @param vector3d NEVector3D to copy from.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithVector3D:(NEVector3D)vector3d confidence:(double)confidence;

/**
 * @param x X value
 * @param y Y value
 * @param z Z value
 */
- (instancetype)initWithX:(double)x y:(double)y z:(double)z;

/**
 * @param x X value
 * @param y Y value
 * @param z Z value
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithX:(double)x y:(double)y z:(double)z confidence:(double)confidence;

/**
 * Parse a string in serialized form.
 * @param string The serialized string, as generated by serialize()
 *
 * @return `nil` if unserialization failed.
 */
+ (instancetype _Nullable)unserializeWithString:(NSString*)string;

@property(nonatomic, readonly) NEVector3D value DEPRECATED_ATTRIBUTE;

/**
 * The x coordinate.
 */
@property(nonatomic, readwrite) double x;

/**
 * The y coordinate.
 */
@property(nonatomic, readwrite) double y;

/**
 * The z coordinate.
 */
@property(nonatomic, readwrite) double z;

/**
 * @return The magnitude of the vector. This is slower than `magnitudeSquared`.
 */
- (double)magnitude;

/**
 * @return The square of the magnitude of the vector. This is faster than `magnitude`.
 */
- (double)magnitudeSquared;

/**
 * @return The vector scaled to have a length of 1.0 - i.e. a unit vector.
 */
- (NEXVector3D*)normalized;

/**
 * @return A hash value representing the state of the Type.
 *          Can be used for checking equality.
 */
@property(nonatomic, readonly) NSUInteger hash;

/**
 * @return The name of the concrete value class extending NEXSensorItem.
 */
@property(nonatomic, readonly) NSString* type;

/**
 * @return A human-readable format of the held data.
 */
@property(nonatomic, readonly) NSString* description;

/**
 * @return A machine-readable format of the held data.  Returns `nil` if @p type is invalid, or if
 * serialization failed.
 */
- (NSString* _Nullable)serialize;

/**
 * Strict equality comparison.
 *
 * @see NEVector3D_isEqual
 *
 * @param object Value to compare with.
 */
- (BOOL)isEqual:(id _Nullable)object;

/**
 * Convert the Objective-C class to a C-compatible struct.
 */
- (NEVector3D)c_val;

@end

NS_ASSUME_NONNULL_END
